package	jp.co.sds_corp.tool.bean;

import java.io.PrintWriter;
import java.text.ParseException;
import java.util.Vector;

import jp.co.sds_corp.util.common.CmnString;

public class TelegramCreator extends BeanCreator
{
	public TelegramCreator( String file ) {
		super( file );
	}

	class TelegramInfo extends BeanInfo
	{
		int len;

		TelegramInfo( String name, String type, int len )
			throws ParseException
		{
			super( name, type );
			this.len = len;
		}
		void printVar( PrintWriter out ) {
			if ( isControlChar( this )) {
				return;
			}
			super.printVar( out );
		}
		void printBean( PrintWriter out ) {
			if ( isControlChar( this )) {
				return;
			}
			super.printBean( out );
		}
	}

	protected boolean isControlChar( TelegramInfo bean ) {
		if ( bean.name.equals( "STX" ) || bean.name.equals( "ETX" )) {
			return true;
		}
		return false;
	}

	protected void printBean( PrintWriter out, Vector<BeanInfo> vec ) {
		super.printBean( out, vec );

		out.println( "\tpublic String debugString() {" );
		out.println( "\t\tString ret = \"\";" );
		for ( int i = 0; i < vec.size(); i++ ) {
			TelegramInfo bean = (TelegramInfo )vec.get( i );
			if ( isControlChar( bean )) {
				continue;
			}
			out.println( "\t\tret += \"" + bean.name + "=[\" + "
							+ "get" + bean.func + "() + \"]\\n\";" );
		}
		out.println( "\t\treturn ret;" );
		out.println( "\t}" );
		out.println( "" );
	}

	protected BeanInfo convertLine( String line ) throws ParseException {
		String[] buf = CmnString.getStringToken( line, "\t", true );
		TelegramInfo bean = null;
		int len;
		switch ( buf.length ) {
		case 4:
			len = Integer.valueOf( buf[3] ).intValue();
			bean = new TelegramInfo( buf[1], "String", len );
			break;
		case 5:
			len = Integer.valueOf( buf[4] ).intValue();
			bean = new TelegramInfo( buf[2], buf[0], len );
			break;
		default:
			break;
		}
		return bean;
	}

	public static void main( String[] args ) {
		for ( int i = 0; i < args.length; i++ ) {
			try {
				TelegramCreator obj = new TelegramCreator( args[i] );
				obj.convert();
			} catch ( Exception e ) {
				e.printStackTrace();
			}
		}
	}
}
