package jp.co.sds_corp.tool.check;

import java.util.ArrayList;
import java.util.List;

public abstract class Checker
{
	List<ProgressListener> listListener = new ArrayList<ProgressListener>();
	String info = "";
	String error;
	String description;

	public void clearError() {
		this.info = "";
		this.error = "";
		this.description = "";
	}

	public String getInfo() {
		return info;
	}
	public void setInfo(String info) {
		this.info = info;
	}
	public void addInfo(String info) {
		this.info += info + "\n";
	}

	public String getError() {
		return error;
	}
	public void setError(String error) {
		this.error = error;
	}
	public void addError(String error) {
		this.error += error + "\n";
		addDescription(error);
	}

	public String getDescription() {
		return description;
	}
	public void setDescription(String description) {
		this.description = description;
	}
	public void addDescription(String description) {
		this.description += description + "\n";
	}
	public void addDescription(Exception ex) {
		this.description += ex.toString();
		Throwable cur = ex;
		for ( ;; ) {
			StackTraceElement[] stacks = cur.getStackTrace();
			for ( StackTraceElement stack : stacks ) {
				this.description += "\n\t" + stack.toString();
			}
			cur = cur.getCause();
			if ( cur == null ) {
				break;
			}
			this.description += "\nCaused by: " + cur.toString();
		}
		this.description += "\n";
	}

	public void addProgressListener(ProgressListener listener) {
		listListener.add(listener);
	}
	public void removeProgressListener(ProgressListener listener) {
		listListener.remove(listener);
	}
	public void fireProgressNotify(ProgressListener.Type type, String message) {
		for (ProgressListener listener : listListener) {
			listener.progressNotify(type, message);
		}
	}

	public abstract int getCheckCount();
	public abstract boolean check();
}
