package jp.co.sds_corp.tool.http.server;

import jp.co.sds_corp.http.server.HttpServer;
import jp.co.sds_corp.util.config.IConfigurable;
import jp.co.sds_corp.util.config.IConfiguration;
import jp.co.sds_corp.tool.test.TestRunner;

public class HttpServerRunner implements TestRunner, IConfigurable
{
	HttpServer server;

	@Override
	public void init( IConfiguration config ) throws Exception {
		server = new HttpServer();
		server.init(config);
	}

	@Override
	public void startService() throws Exception {
		server.start();
	}

	@Override
	public void startThread() throws Exception {
	}

	@Override
	public void testCase( IConfiguration config, String param ) throws Exception {
		String ret = null;
		if (param == null) {
		} else
		if (param.equals("print")) {
			ret = server.printConfig();
		} else
		if (param.equals("cache")) {
			ret = server.printCache();
		} else
		if (param.equals("mime")) {
			ret = server.printMime();
		}

		if (ret != null) {
			System.out.println(ret);
		}
	}

	@Override
	public void stopThread() throws Exception {
	}

	@Override
	public void stopService() throws Exception {
		server.stop();
	}

}
